include:
    - template: Security/Secret-Detection.gitlab-ci.yml
    - template: Security/SAST.gitlab-ci.yml

default:
    image: node:14

workflow:
    rules:
        - if: $CI_COMMIT_BRANCH

stages:
    - install-dependencies
    - test
    - build
    - release

.npm-cache: &npm-cache
    key: ${CI_COMMIT_REF_SLUG}
    paths:
        - .npm/
    policy: pull

.dist-cache: &dist-cache
    key: ${CI_COMMIT_REF_SLUG}
    paths:
        - dist/
    policy: pull

.npm-ci: &npm-ci
    - npm ci --cache .npm --prefer-offline

npm-install:
    stage: install-dependencies
    script:
        - *npm-ci
    cache:
        key: ${CI_COMMIT_REF_SLUG}
        paths:
            - .npm/
        policy: push

.eslint:
    stage: test
    before_script:
        - *npm-ci
    script:
        - npm run lint
    cache: *npm-cache

mocha:
    stage: test
    before_script:
        - *npm-ci
    script:
        - npx nyc --reporter=cobertura --reporter=text mocha --reporter mocha-junit-reporter
    artifacts:
        when: always
        paths:
            - test-results.xml
            - coverage/cobertura-coverage.xml
        reports:
            junit: test-results.xml
            cobertura: coverage/cobertura-coverage.xml
    cache: *npm-cache

transpile:
    stage: build
    before_script:
        - *npm-ci
    script:
        - npm run build
    cache:
        - *npm-cache
        - key: ${CI_COMMIT_REF_SLUG}
          paths:
              - dist/
          policy: push

publish:
    stage: release
    variables:
        NPM_TOKEN: ${CI_JOB_TOKEN}
    before_script:
        - *npm-ci
        - |
            {
              echo "@${CI_PROJECT_ROOT_NAMESPACE}:registry=${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/packages/npm/"
              echo "${CI_API_V4_URL#https?}/projects/${CI_PROJECT_ID}/packages/npm/:_authToken=\${CI_JOB_TOKEN}"
            } | tee --append .npmrc
    script:
        - npm run semantic-release
    rules:
        - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
    cache:
        - *npm-cache
        - *dist-cache
